"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @abstract
 */
var MyEventManagerPlugin = (function () {
    /**
     * @param {?} _doc
     */
    function MyEventManagerPlugin(_doc) {
        this._doc = _doc;
    }
    /**
     * @abstract
     * @param {?} eventName
     * @return {?}
     */
    MyEventManagerPlugin.prototype.supports = function (eventName) { };
    /**
     * @abstract
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    MyEventManagerPlugin.prototype.addEventListener = function (element, eventName, handler) { };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    MyEventManagerPlugin.prototype.addGlobalEventListener = function (element, eventName, handler) {
        var /** @type {?} */ target;
        if (element === 'document')
            target = this._doc;
        else if (element === 'window' && typeof (window) !== undefined)
            target = window;
        if (!target) {
            throw new Error("Unsupported event target " + target + " for event " + eventName);
        }
        return this.addEventListener(target, eventName, handler);
    };
    ;
    return MyEventManagerPlugin;
}());
exports.MyEventManagerPlugin = MyEventManagerPlugin;
function MyEventManagerPlugin_tsickle_Closure_declarations() {
    /** @type {?} */
    MyEventManagerPlugin.prototype.manager;
    /** @type {?} */
    MyEventManagerPlugin.prototype._doc;
}
