"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
/**
 * Register multiple event listeners
 *
 * Usage:
 * <button (multi.focus,select)="foo($event)"></button>
 *
 */
var MultiEventPlugin = (function (_super) {
    __extends(MultiEventPlugin, _super);
    /**
     * @param {?} doc
     */
    function MultiEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    MultiEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('multi.') === 0;
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    MultiEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var /** @type {?} */ eventNames = eventName.slice(6).split(',');
        var /** @type {?} */ eventListeners = eventNames.map(function (x) {
            return _this.manager.addEventListener(element, x, handler);
        });
        return function () {
            eventListeners.forEach(function (x) { return x(); });
        };
    };
    return MultiEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
MultiEventPlugin.decorators = [
    { type: core_1.Injectable },
];
/**
 * @nocollapse
 */
MultiEventPlugin.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Inject, args: [platform_browser_1.DOCUMENT,] },] },
]; };
exports.MultiEventPlugin = MultiEventPlugin;
function MultiEventPlugin_tsickle_Closure_declarations() {
    /** @type {?} */
    MultiEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    MultiEventPlugin.ctorParameters;
}
