"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
/**
 * Automatically unregister an event listener after the event fired once
 *
 * Usage:
 * <button (once.click)="foo()">...</button>
 *
 */
var OnceEventPlugin = (function (_super) {
    __extends(OnceEventPlugin, _super);
    /**
     * @param {?} doc
     */
    function OnceEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    OnceEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('once.') === 0;
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    OnceEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var /** @type {?} */ realEventName = eventName.slice(5);
        var /** @type {?} */ active = true;
        var /** @type {?} */ eventListener = this.manager.addEventListener(element, realEventName, function ($event) {
            eventListener();
            active = false;
            handler($event);
        });
        return function () {
            if (active)
                eventListener();
        };
    };
    return OnceEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
OnceEventPlugin.decorators = [
    { type: core_1.Injectable },
];
/**
 * @nocollapse
 */
OnceEventPlugin.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Inject, args: [platform_browser_1.DOCUMENT,] },] },
]; };
exports.OnceEventPlugin = OnceEventPlugin;
function OnceEventPlugin_tsickle_Closure_declarations() {
    /** @type {?} */
    OnceEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    OnceEventPlugin.ctorParameters;
}
