"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
/**
 * Quick-firing 'up' and 'down' events that work cross-browser for mouse and touch events
 *
 * Usage:
 * <button (down)="activate()" (up)="deactivate()"></button>
 *
 */
var TouchEventPlugin = (function (_super) {
    __extends(TouchEventPlugin, _super);
    /**
     * @param {?} doc
     */
    function TouchEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    TouchEventPlugin.prototype.supports = function (eventName) {
        return eventName === 'down' || eventName === 'up';
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    TouchEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var /** @type {?} */ eventNames = (eventName === 'down')
            ? ['mousedown', 'touchstart', 'pointerdown']
            : ['mouseup', 'touchend', 'pointerup'];
        var /** @type {?} */ eventListeners = eventNames.map(function (x) {
            return _this.manager.addEventListener(element, x, function (e) {
                // prevent default so only one of the event listeners is fired
                e.preventDefault();
                handler(e);
            });
        });
        return function () {
            eventListeners.forEach(function (x) { return x(); });
        };
    };
    return TouchEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
TouchEventPlugin.decorators = [
    { type: core_1.Injectable },
];
/**
 * @nocollapse
 */
TouchEventPlugin.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Inject, args: [platform_browser_1.DOCUMENT,] },] },
]; };
exports.TouchEventPlugin = TouchEventPlugin;
function TouchEventPlugin_tsickle_Closure_declarations() {
    /** @type {?} */
    TouchEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    TouchEventPlugin.ctorParameters;
}
